# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import typing_extensions
from ..core.serialization import FieldMetadata
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CreateLangfuseCredentialDto(UncheckedBaseModel):
    provider: typing.Literal["langfuse"] = "langfuse"
    public_key: typing_extensions.Annotated[str, FieldMetadata(alias="publicKey")] = pydantic.Field()
    """
    The public key for Langfuse project. Eg: pk-lf-...
    """

    api_key: typing_extensions.Annotated[str, FieldMetadata(alias="apiKey")] = pydantic.Field()
    """
    The secret key for Langfuse project. Eg: sk-lf-... .This is not returned in the API.
    """

    api_url: typing_extensions.Annotated[str, FieldMetadata(alias="apiUrl")] = pydantic.Field()
    """
    The host URL for Langfuse project. Eg: https://cloud.langfuse.com
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    This is the name of credential. This is just for your reference.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
