# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import typing_extensions
from .o_auth_2_authentication_plan import OAuth2AuthenticationPlan
from ..core.serialization import FieldMetadata
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CreateWebhookCredentialDto(UncheckedBaseModel):
    provider: typing.Literal["webhook"] = "webhook"
    authentication_plan: typing_extensions.Annotated[
        OAuth2AuthenticationPlan, FieldMetadata(alias="authenticationPlan")
    ] = pydantic.Field()
    """
    This is the authentication plan. Currently supports OAuth2 RFC 6749.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    This is the name of credential. This is just for your reference.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
