# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
import pydantic
from .cloudflare_r_2_bucket_plan import CloudflareR2BucketPlan
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class UpdateCloudflareCredentialDto(UncheckedBaseModel):
    account_id: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="accountId")] = pydantic.Field(
        default=None
    )
    """
    Cloudflare Account Id.
    """

    api_key: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="apiKey")] = pydantic.Field(
        default=None
    )
    """
    Cloudflare API Key / Token.
    """

    account_email: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="accountEmail")] = (
        pydantic.Field(default=None)
    )
    """
    Cloudflare Account Email.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    This is the name of credential. This is just for your reference.
    """

    bucket_plan: typing_extensions.Annotated[
        typing.Optional[CloudflareR2BucketPlan], FieldMetadata(alias="bucketPlan")
    ] = pydantic.Field(default=None)
    """
    This is the bucket plan that can be provided to store call artifacts in R2
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
